
import requests
import json
import os
import sys
import time
import shutil
import subprocess
import random


from api import *


account_email = ""
password = ""


# ---------------------------------------------------------------------------------------------
class bcolors:
    BLUE = '\033[94m'
    GREEN = '\033[92m'
    ORANGE = '\033[93m'
    RED = '\033[91m'
    ENDC = '\033[0m'
    BOLD = '\033[1m'
    UNDERLINE = '\033[4m'

CHECK_MARK = bcolors.GREEN + u'\u2713' + bcolors.ENDC
ERROR_MARK = bcolors.RED + u'\u2A09' + bcolors.ENDC
WARNING_MARK = bcolors.ORANGE + u'\u26A0' + bcolors.ENDC

# ---------------------------------------------------------------------------------------------
def dico_api_test():


	# -----------------------------------------
	token = login(account_email, password)
	if token != "":
		print(CHECK_MARK + " - login with a valid account")
	else:
		print(ERROR_MARK + " - login with a valid account")
	print("")

	
	# -----------------------------------------
	response = dico_language_list(token)
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_language_list error')
		return response

	print(CHECK_MARK + " - dico_language_list")
	#print(json_response)
	for item in json_response:
		#print(item['id'])
		print(item)

	print("")

	# -----------------------------------------
	response = dico_nature_list(token)
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_nature_list error')
		return response

	print(CHECK_MARK + " - dico_nature_list")
	#print(json_response)
	for item in json_response:
		print(item)

	print("")

	
	# -----------------------------------------
	response = dico_phoneme_list(token,'2')
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_phoneme_list error')
		return response

	print(CHECK_MARK + " - dico_phoneme_list")
	#print(json_response)
	for item in json_response:
		print(item)

	print("")


	# -----------------------------------------
	response = dico_list(token)
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_list error')
		return response

	print(CHECK_MARK + " - dico_list")
	#print(json_response)
	for item in json_response:
		print(item)

	print("")


	# -----------------------------------------
	dico_test_name = "test_add_dico"
	#{'id': 13, 'language_iso': 'enu', 'language_full': 'English (United States)', 'language_legacy': 'USEnglish', 'language_encoding': 'CP1252'}
	response = dico_add(token,dico_test_name,"13","")
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_add error' + response.text)
		return response

	print(CHECK_MARK + " - dico_add")
	print(json_response)

	# store dico id
	response = dico_list(token)
	json_response = response.json()
	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_list error')
		return response

	for item in json_response:
		if item['dic_name'] == dico_test_name:
			dico_test_id = str(item['id'])
	

	print("")

	# -----------------------------------------
	response = dico_get_transcription(token,"hello","13")
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_check_word error')
		return response

	print(CHECK_MARK + " - dico_check_word")
	print(json_response)
	#print(json_response['transcription'])


	print("")


	# -----------------------------------------
	#{'id': 13, 'nature': 'NOUN'}
	response = dico_set_entry(token,dico_test_id,"","goodbye","13","p_h @ t_h EI1 4 @U","true")
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_set_entry error')
		return response

	print(CHECK_MARK + " - dico_set_entry")
	print(json_response)

	print("")


	# -----------------------------------------
	response = dico_content(token,dico_test_id)
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_content error')
		return response

	print(CHECK_MARK + " - dico_content")
	for item in json_response:
		print(item)
		entry_id = str(item['id'])

	print("")


	# -----------------------------------------
	response = dico_export(token,dico_test_id,dico_test_name)
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_export error')
		return response

	print(CHECK_MARK + " - dico_export")
	print(json_response)
	

	print("")


	# -----------------------------------------
	response = dico_delete_entry(token,dico_test_id,entry_id)
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_delete_entry error')
		return response

	print(CHECK_MARK + " - dico_delete_entry")
	print(json_response)

	print("")


	# -----------------------------------------
	response = dico_delete(token,dico_test_id)
	json_response = response.json()

	if response.status_code != 200:
		print(ERROR_MARK + ' - dico_delete error')
		return response

	print(CHECK_MARK + " - dico_delete")
	print(json_response)
	
	print("")

		
# ---------------------------------------------------------------------------------------------
if __name__ == "__main__":

	dico_api_test()

