
import requests
import json
import os
import sys
import urllib


server_url = 'https://www.acapela-cloud.com'

# ---------------------------------------------------------------------------------------------
def login(email, password):

	headers = {
		'Content-Type': 'application/json',
	}
	data = '{"email": "' + email + '","password": "' + password + '"}'

	response = requests.post(server_url + '/api/login/', headers=headers, data=data)

	# get token from login
	json_response = response.json()

	if response.status_code == 200:
		token = json_response["token"]
		return token
	else:
		return ""

# ---------------------------------------------------------------------------------------------
def dico_language_list(token=""):

	headers = {
    	'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	params = {'type': 'language_list'}
	response = requests.get(server_url + '/api/dicoeditor/', headers=headers, params=params)

	return response


# ---------------------------------------------------------------------------------------------
def dico_nature_list(token=""):

	headers = {
    	'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	params = {'type': 'nature_list'}
	response = requests.get(server_url + '/api/dicoeditor/', headers=headers, params=params)

	return response


# ---------------------------------------------------------------------------------------------
def dico_phoneme_list(token,language_id):

	headers = {
    	'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	params = {'type': 'phoneme_list','language': language_id}
	response = requests.get(server_url + '/api/dicoeditor/', headers=headers, params=params)

	return response


# ---------------------------------------------------------------------------------------------
def dico_list(token=""):

	headers = {
    	'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	params = {'type': 'dico_list'}
	response = requests.get(server_url + '/api/dicoeditor/', headers=headers, params=params)

	return response

# ---------------------------------------------------------------------------------------------
def dico_add(token,name,language,voice):

	headers = {
		'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	data = '{"type": "' + "add_dico" + '","name": "' + name  + '","language": "' + language + '","voice": "' + voice + '"}'
	response = requests.post(server_url + '/api/dicoeditor/',  headers=headers, data=data)

	return response


# ---------------------------------------------------------------------------------------------
# id to delete in lexicon / name to delete the file
def dico_delete(token,dic_id):

	headers = {
		'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	data = '{"type": "' + "delete_dico" + '","dic_id": "' + dic_id + '"}'
	response = requests.delete(server_url + '/api/dicoeditor/',  headers=headers, data=data)

	return response


# ---------------------------------------------------------------------------------------------
def dico_content(token,dic_id):

	headers = {
    	'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	params = {'type': 'dico_content','dic_id': dic_id}
	response = requests.get(server_url + '/api/dicoeditor/', headers=headers, params=params)

	return response


# ---------------------------------------------------------------------------------------------
def dico_get_transcription(token,word,language,voice=""):

	headers = {
		'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	params = {'type': 'check_word','word': word,'language': language,'voice': voice}
	response = requests.get(server_url + '/api/dicoeditor/', headers=headers, params=params)

	return response


# ---------------------------------------------------------------------------------------------
def dico_set_entry(token,dic_id,entry_id,word,nature,transcription,validated):

	headers = {
		'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	data = '{"type": "' + "add_entry" + '","dic_id": "' + dic_id  + '","entry_id": "' + entry_id  + '","word": "' + word + '","nature": "' + nature + '","transcription": "' + transcription + '","validated": "' + validated + '"}'
	response = requests.post(server_url + '/api/dicoeditor/',  headers=headers, data=data)

	return response


# ---------------------------------------------------------------------------------------------
def dico_delete_entry(token,dic_id,entry_id):

	headers = {
		'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	data = '{"type": "' + "delete_entry" + '","dic_id": "' + dic_id  + '","entry_id": "' + entry_id + '"}'
	response = requests.delete(server_url + '/api/dicoeditor/',  headers=headers, data=data)

	return response


# ---------------------------------------------------------------------------------------------
def dico_export(token,dic_id,dic_name):

	headers = {
		'Authorization': 'Token ' + token,
    	'Content-Type': 'application/json',
	}

	data = '{"type": "' + "export_dico" + '","dic_id": "' + dic_id  + '","dic_name": "' + dic_name + '"}'
	response = requests.post(server_url + '/api/dicoeditor/',  headers=headers, data=data)

	return response


